﻿using System;
using UnityEngine;

namespace Overdash.Common
{
    [RequireComponent(typeof(Collider2D))]
    public class SubscribableTrigger2D : MonoBehaviour
    {   
        public event Action<Collider2D> OnTriggerEnter;
        public event Action<Collider2D> OnTriggerStay;
        public event Action<Collider2D> OnTriggerExit;
        
        private void OnTriggerEnter2D(Collider2D other) => OnTriggerEnter?.Invoke(other);
        private void OnTriggerStay2D(Collider2D other) => OnTriggerStay?.Invoke(other);
        private void OnTriggerExit2D(Collider2D other) => OnTriggerExit?.Invoke(other);
    }
}