﻿using System;
using System.Collections.Generic;
using Overdash.Player;
using UnityEngine;

namespace Overdash.General
{
    public abstract class PickupItem : MonoBehaviour
    {
        public event Action<PlayerCharacter> OnPickup;
        public bool isPickable { get; set; } = true;
        
        public void Pickup(PlayerCharacter playerCharacter)
        {
            if (isPickable)
            {
                OnPickup?.Invoke(playerCharacter);
                Destroy(gameObject);
            }
                
            else
                Debug.LogWarning("Trying to pick up a pickup a non-pickable item");
        }
    }
}