using System.Collections.Generic;
using UnityEngine;

namespace Overdash.Levels
{
    public class AmmoSpawner : MonoBehaviour
    {
    
        [SerializeField] private float averageDelaySec;
        [SerializeField] private float delayVarianceSec;
        [SerializeField] private float firstSpawnDelay;
        [SerializeField] private int maxSpawnedItems;
        [SerializeField] private List<GameObject> ammoPrefab = new();

        private float nextSpawnTime;
        private int spawnedItems = 0;


        // Start is called before the first frame update
        void Start()
        {
            nextSpawnTime = Time.time + firstSpawnDelay;
        }

        // Update is called once per frame
        void Update()
        {
            if (Time.time > nextSpawnTime && spawnedItems <= maxSpawnedItems)
            {
                SpawnAmmo();
                nextSpawnTime = Time.time + averageDelaySec + Random.Range(-delayVarianceSec, delayVarianceSec);
                spawnedItems += 1;
            }
        }
        private void SpawnAmmo()
        {
            GameObject ammo = Instantiate(ammoPrefab[Random.Range(0, ammoPrefab.Count)], transform.position, Quaternion.identity);
            ammo.GetComponent<Rigidbody2D>().AddForce(new Vector2(-1, 0));
        }
    }
}
