using System;
using System.Collections.Generic;
using Overdash.Common;
using Overdash.Global;
using UnityEngine;

namespace Overdash.Levels
{
    public class LevelManager : MonoBehaviourSingleton<LevelManager>
    {
        public static event Action<Level> OnLevelLoaded; 
        public static Level currentLevel { get; private set; }
        
    
        [SerializeField] private List<GameObject> levelPrefabs;
    
    
        // Start is called before the first frame update
        protected override void Awake()
        {
            base.Awake();
            RoundLoop.OnRoundEnd += () => Destroy(currentLevel.gameObject);
            RoundLoop.OnNewRound += () =>
            {
                var level = levelPrefabs[UnityEngine.Random.Range(0, levelPrefabs.Count)];
                currentLevel = Instantiate(level).GetComponent<Level>();
                OnLevelLoaded?.Invoke(currentLevel);
            };
        }
    }
}
