using System;
using UnityEngine;
using UnityEngine.InputSystem;

namespace Overdash.Player
{
    [RequireComponent(typeof(PlayerInput))]
    public class Player : MonoBehaviour
    {
        public event Action<PlayerDeathInfo> OnCharacterKilled;
        
        public PlayerInput input { get; private set; }
        public int number { get; private set; }
        public Color color { get; private set; }
        
        public PlayerCharacter controlledCharacter { get; private set; }

        private void Awake()
        {
            input = GetComponent<PlayerInput>();
        }

        public void Initialize(int number, Color color)
        {
            this.number = number;
            this.color = color;
        }
        
        public void AssignCharacter(PlayerCharacter character)
        {
            controlledCharacter = character;
            controlledCharacter.OnKilled += deathInfo => OnCharacterKilled?.Invoke(deathInfo);
        }
    }
}


