﻿using System;
using System.Collections.Generic;
using System.Linq;
using Overdash.Combat;
using Overdash.Common;
using Overdash.General;
using UnityEngine;

namespace Overdash.Player
{
    [RequireComponent(typeof(SubscribableTrigger2D))]
    public class PlayerPickupField : MonoBehaviour
    {
        public readonly List<Func<PickupItem, bool>> PickupCallbacks = new ();
        
        private PlayerCharacter player;
        
        private void Awake()
        {
            GetComponent<SubscribableTrigger2D>().OnTriggerEnter += TryPickup;
            GetComponent<SubscribableTrigger2D>().OnTriggerStay  += TryPickup;
            player = GetComponentInParent<PlayerCharacter>();
        } 
        
        private void TryPickup(Component other)
        {
            if (other.TryGetComponent(out PickupItem pickupItem) && pickupItem.isPickable && PickupCallbacks.Any(callback => callback(pickupItem)))
                pickupItem.Pickup(player);
        }
    }
}